/*==========================================================================*/
/* KEYS.H - keystroke codes for the IBM PC                                  */
/*                                                                          */
/* (C) COPYRIGHT 1984  Marc Adler      All Rights Reserved                  */
/*==========================================================================*/

/*---------------------------------------------------------------------------
  CODES NOT USED (so far)
   167-171, 179-186, 197-198, 202, 204, 206
----------------------------------------------------------------------------*/

#define F1           187
#define F2           188
#define F3           189
#define F4           190
#define F5           191
#define F6           192
#define F7           193
#define F8           194
#define F9           195
#define F10          196

/*------------------------- SHIFTED FUNCTION KEYS -------------------------*/

#define SH_F1        212
#define SH_F2        213
#define SH_F3        214
#define SH_F4        215
#define SH_F5        216
#define SH_F6        217
#define SH_F7        218
#define SH_F8        219
#define SH_F9        220
#define SH_F10       221

/*--------------------------- ALT FUNCTION KEYS ----------------------------*/

#define ALT_F1       232
#define ALT_F2       233
#define ALT_F3       234
#define ALT_F4       235
#define ALT_F5       236
#define ALT_F6       237
#define ALT_F7       238
#define ALT_F8       239
#define ALT_F9       240
#define ALT_F10      241

/*--------------------------- CTRL FUNCTION KEYS ----------------------------*/

#define CTRL_F1      222
#define CTRL_F2      223
#define CTRL_F3      224
#define CTRL_F4      225
#define CTRL_F5      226
#define CTRL_F6      227
#define CTRL_F7      228
#define CTRL_F8      229
#define CTRL_F9      230
#define CTRL_F10     231

/*--------------------------- KEYPAD FUNCTION KEYS --------------------------*/

#define ESC           27
#define _UP           200
#define _DOWN         208
#define _LEFT         203
#define _RIGHT        205
#define _INSCHAR      210
#define _DELCHAR      211
#define BACKSPACE     8
#define CTRL_BKSP     127

/*------------------------ CONTROL FUNCTION KEYS ---------------------------*/

#define HOME          199
#define CTRL_HOME     247
#define END           207
#define CTRL_END      245
#define PGUP          201
#define PGDN          209
#define CTRL_PGUP     132
#define CTRL_PGDN     246
#define CTRL_LEFT     243
#define CTRL_RIGHT    244

/*------------------- SHIFTED KEYPAD KEYS and PRTSCR KEY --------------------*/

#define SH_HOME       133
#define SH_UP         134
#define SH_PGUP       135
#define SH_MINUS      136
#define SH_LEFT       137
#define SH_FIVE       138
#define SH_RIGHT      139
#define SH_PLUS       140
#define SH_END        141
#define SH_DOWN       142
#define SH_PGDN       154
#define SH_INS        155
#define SH_DEL        156
#define PRTSCREEN     157
#define CTRL_PRTSCREEN  242
#define TAB           9
#define BACKTAB       143


/*--------------------------- CONTROL KEYS < ' ' ----------------------------*/

#define CTRL_A     1
#define CTRL_B     2
#define CTRL_C     3
#define CTRL_D     4
#define CTRL_E     5
#define CTRL_F     6
#define CTRL_G     7
#define CTRL_H     8
#define CTRL_I     9
#define CTRL_J     10
#define CTRL_K     11
#define CTRL_L     12
#define CTRL_M     13
#define CTRL_N     14
#define CTRL_O     15
#define CTRL_P     16
#define CTRL_Q     17
#define CTRL_R     18
#define CTRL_S     19
#define CTRL_T     20
#define CTRL_U     21
#define CTRL_V     22
#define CTRL_W     23
#define CTRL_X     24
#define CTRL_Y     25
#define CTRL_Z     26

/*------------------------------- ALT KEYS -------------------------------*/

#define ALT_A        158
#define ALT_B        176
#define ALT_C        174
#define ALT_D        160
#define ALT_E        146
#define ALT_F        161
#define ALT_G        162
#define ALT_H        163
#define ALT_I        151
#define ALT_J        164
#define ALT_K        165
#define ALT_L        166
#define ALT_M        178
#define ALT_N        177
#define ALT_O        152
#define ALT_P        153
#define ALT_Q        144
#define ALT_R        147
#define ALT_S        159
#define ALT_T        148
#define ALT_U        150
#define ALT_V        175
#define ALT_W        145
#define ALT_X        173
#define ALT_Y        149
#define ALT_Z        172


#define ALT_1        248
#define ALT_2        249
#define ALT_3        250
#define ALT_4        251
#define ALT_5        252
#define ALT_6        253
#define ALT_7        254
#define ALT_8        255
#define ALT_9        128
#define ALT_0        129
#define ALT_MINUS    130
#define ALT_PLUS     131
